
/*********************************************************
 * Arudion    whmp 2013 7 30
 * 
 * an example for MRETV 
 * 
 * This is a rather complicated example when most times a few beeps or a short sequence of
 * tones will be all thats needed.
 * 
 * Musical ability would make this sound way better than my buggy auto conversion script 
 * did. And some decent sound samples. And more donuts.
 * Anyhow the point is the Arduino can beep, never meant for music
 * 
 * 
 * setaudior(soundindex,duration); // expects an array called sound[] to exist;
 * setaudiol(soundindex,duration); // duration in 60th/ second, 0 off 255 forever
 * or
 * ssampler(sample *,duration) ; // plays a sample
 * ssamplel(sample *,duration) ; // duration in 60th/ second, 0 off 255 forever
 * 
 * The inline assembly language may be of interest to some.
 * 
 * Keys of interest <>+-sStT numlock ctrl ... more in source.
 * 
 * About Extension defines.
 * 
 * Defining these in the MRETV library folder allows for extra optimisation and 
 * improved performance. All examples are predefined in Arduino\libraries\MRETV\MRETV.extensions 
 * 
 * for MasteRasterExtendedTransmissionVision 1
 **********************************************************/
#include <MrETV.h> 

#ifndef Arudion // make sure the extensions are set correctly
#error Please define Arudion in arduino\libraries\MRETV\MRETV.extensions , See comments at start of sketch
#endif
/* set these MRETV Extensions  in libraries/MRETV/MrEtv.extensions 
 #ifdef Arudion
 #ifdef __AVR_ATmega168__
 #define firmwareps2port
 #else 
 #define firmwaremultiport
 #endif
 #define dualaudio    
 #define userextension   background()
 #define translatekeys 
 #define mergstreams 
 #define fontheight 4
 #endif
 */

#include "audiodata.h" // the melody's... "Damit Jim i'm a programmer not a musician" HELP! 
#include "bitfont.h"  // for pixel level graphics
#include "saw.h"     // sound wave forms - HELP need some decent ones.  


// an array of pointers to sound samples, they come from the header
PROGMEM const char * sounds [] = {  // sounds from low to high
  silent,
#ifdef __AVR_ATmega168__
#else
  //0  auto play midish number
  sawCo,sawDbo,sawDo,sawEbo,sawEo,sawFo,sawGbo,sawGo,
  sawAbo,sawAo,sawBbo,sawBo,
  //8
  sawCo1,sawDbo1,sawDo1,sawEbo1,
  sawEo1,sawFo1,sawGbo1, sawGo1,
  //16
  sawAbo1,sawAo1,sawBbo1,sawBo1,
#endif
  sawCo2,sawDbo2,sawDo2,sawEbo2,
  //24
  sawEo2,sawFo2,sawGbo2,sawGo2,sawAbo2,sawAo2,sawBbo2,sawBo2,
  //32
  sawCo3,sawDbo3,sawDo3,sawEbo3,sawEo3,sawFo3,sawGbo3,sawGo3,
  //40
  sawAbo3,sawAo3,sawBbo3,sawBo3,
  sawCo4,sawDbo4,sawDo4,sawEbo4,
  //48
  sawEo4,sawFo4,sawGbo4,sawGo4,sawAbo4,sawAo4,sawBbo4,sawBo4,
  //56
  sawCo5,sawDbo5,sawDo5,sawEbo5,sawEo5,sawFo5,sawGbo5,sawGo5,
  //64
  sawAbo5,sawAo5,sawBbo5,sawBo5,
  sawCo6,sawDbo6,sawDo6,sawEbo6,
  //72
  sawEo6,sawFo6,sawGbo6,sawGo6,sawAbo6,sawAo6,sawBbo6,sawBo6,
  //80
  sawCo7,sawDbo7,sawDo7,sawEbo7,sawEo7,sawFo7,sawGbo7,sawGo7,
  //88
  sawAbo7,sawAo7,sawBbo7,sawBo7,
  silent,
};

#define mapwide 15   // the display feild
#define maptall 53  
#define mapsize (maptall*mapwide)
volatile uchar  asciibuf[mapsize];    

uint songindex=0; // don't start too soon !
uchar nextevent,tempo,tune; // nextevent is a count down.
uchar cr,cl, nowplaying;

// array of notes actually played
//its possible to replace played notes with null entry's in array to save progmem
#ifdef __AVR_ATmega168__
#else 
uchar nu[14];
#endif


//  Interrupt called screen top-1 and screenbottom+1
void background(){
  uchar note=0,limiter=2; // this is an interrupt keep it short
  if(( Video.LineCount== (Video.ScreenBottom+1U))) {  // only once a screen 
    if(nowplaying>10){ // means start new tune
      nowplaying-=10;
      songindex=0;
      nextevent=0;
      switch( nowplaying)    
      {
      case 3:
        tempo=pgm_read_byte(&song3[songindex++]); 
        tune=pgm_read_byte(&song3[songindex++]);
        break;
      case 2:
        tempo=pgm_read_byte(&song2[songindex++]); 
        tune=pgm_read_byte(&song2[songindex++]);
        break;
      case 1:
        tempo=pgm_read_byte(&song1[songindex++]); 
        tune=pgm_read_byte(&song1[songindex++]);
        break;
      case 4:
        tempo=pgm_read_byte(&song4[songindex++]); 
        tune=pgm_read_byte(&song4[songindex++]);
        break;
      }
    }

    if((songindex)&&(!key_ctr)){ // ctr pauses playback
      while((!nextevent--)){ 
        switch( nowplaying)    
        {
        case 3:
          note=pgm_read_byte(&song3[songindex++]); // get note
          nextevent=pgm_read_byte(&song3[songindex++]);
          break;
        case 2:
          note=pgm_read_byte(&song2[songindex++]); // get note
          nextevent=pgm_read_byte(&song2[songindex++]);
          break;
        case 1:
          note=pgm_read_byte(&song1[songindex++]); // get note
          nextevent=pgm_read_byte(&song1[songindex++]);
          break;
        case 4:
          note=pgm_read_byte(&song4[songindex++]); // get note
          nextevent=pgm_read_byte(&song4[songindex++]);
          break;
        }
#ifdef __AVR_ATmega168__
#else 
        nu[note/8]|=_BV(note&7); // log the use of this note
#endif
        switch (note){
        case 0:
          Video.audiodatar=silent;
          asciibuf[((maptall-(cr%maptall))*mapwide) ]&=~1;  // clear pixel-
          cr=0;                                            // far left, height by frequency
          break;
        case 1:   
          Video.audiodata=silent;
          asciibuf[((maptall-(cl%maptall))*mapwide) ]&=~1;
          cl=0;
          break;
        default:
          if (!cr) {
            cr=note-tune;  // set pitch
            setaudior(cr,255);
            asciibuf[((maptall-(cr%maptall))*mapwide) ]|=1; // set pixel
          }
          else if (!cl){ 
            cl=note-tune; // set pitch
            setaudiol(cl,255);
            asciibuf[((maptall-(cl%maptall))*mapwide) ]|=1;
          }
          break;
        }
        if(nextevent==255)songindex=0; // we are done
        else nextevent=(nextevent+tempo-1)/tempo; // adjust tempo
        if ((nextevent>2)||(!limiter--))break; // don't handle another event this interrupt
      }
    }
  } 
}

void setup(){
  Video.begin(bit4font,asciibuf, maptall*fontheight,mapwide,4,3,(2<<5)+1); 
}

void loop() {
#ifdef __AVR_ATmega168__
#else 
  uchar r=0;
#endif
  int t,scro=1;
  char  startupdelay=20;
  uchar chin,shownote=0;
  uint lastsongindex=0;
  cr=0; // current notes
  cl=0;
  while(1)
  {
    if( startupdelay){ // time for keyboard to init 
      startupdelay--;
      if(! startupdelay) {
        Video.keyrate(0x14);
        nowplaying=11;// song +10 to start playing  
      }
    }
    if(!key_nlock) rsft(); // num lock stops scrolling

    if(songindex){ // update event count
      if(!key_sft) if(songindex!=lastsongindex)score(lastsongindex=songindex);
    }
    else{  // check for  unsetting manually played notes
      if(!alcount)  asciibuf[((maptall-(cl%maptall))*mapwide) ]&=~1; 
      if(!arcount)  asciibuf[((maptall-(cr%maptall))*mapwide) ]&=~1;
    }
#ifdef __AVR_ATmega168__
    if( (chin=Video.read()))  // get user input from keyboard
#else 
        if( (chin=Video.readS()))  // get user input from merged serial+keyboard
#endif
      {
        switch(chin){
        case '?' :  // display used noted
          for (t=0;t<mapsize;t++)asciibuf[t]=0;
#ifdef __AVR_ATmega168__
#else 
          if (r>13)r=0;
          else  score(nu[r++]+1000);
#endif
          break;
        case 0x0d : //enter
          asm volatile("JMP 0x0000\n\t"::);
          break;
        case '<' : //Down
        case ',' : //Down
          if(key_ctr)songindex-=10;
          else         tune++;
          break;
        case '-' : //Down
          tune+=12;
          break;
        case '>' :  //up
        case '.' : //up
          if(key_ctr)songindex+=100;
          else    tune--;
          break;
        case '+' :  //up
        case '=' :  //up
          tune-=12;
          break;
        case ' ' :  //up
          if(key_ctr)      nextevent=0;
          else        nextevent++;
          break;
        case 'S':
          Video.off();
          while(t++);
          while(t++);
          while(t++);
          while(t++);
          Video.on();
          if(scro>0) scro--;
          break;
        case 's':
          if(scro<2)  scro++;
          break;
        case 't':
          tempo--;
          break;
        case 'T':
          tempo++;
          break;
        case '/': 
#ifdef __AVR_ATmega168__
#else 
          score(((nu[nextevent])*100)+nextevent);   
#endif
          break;  
        case '1':   
          nowplaying=11;
          break;
        case '3':   
          nowplaying=13;
          break;
        case '2':   
          nowplaying=12;
          break;
        case '4':   
          nowplaying=14;
          break;
        case '5':
          shownote^=1;
          break;
        case '0':
        case ')':
          for (t=0;t<mapsize;t++)asciibuf[t]=0;
          setaudior(0,255);
          setaudiol(0,255);
          Video.keyrate(0x14);
          startupdelay=0;
          if(key_ctr) score(cr+(256*cl));
          else    songindex=0;
          break;
        }

        if(!songindex&&! startupdelay){ // left channel lower case
          if(chin>= 'a'&&chin<='z'){
            asciibuf[((maptall-(cl%maptall))*mapwide) ]&=~1; 
            cl=chin-'a'+tune+24;
            setaudiol(cl,20);
            asciibuf[((maptall-((cl)%maptall))*mapwide) ]|=1;
            if(shownote)   score(cl);  
          }

          if(chin>='A'&&chin<='Z'){ // right channel uppercase
            asciibuf[((maptall-(cr%maptall))*mapwide) ]&=~1; 
            cr=chin-'a'+tune;
            setaudior(cr,20);
            asciibuf[((maptall-((cr)%maptall))*mapwide) ]|=1;
            if(shownote)   score(cr);  
          }
        }
      }
    // control scrolling speed.
    if(scro){  
      while(Video.LineCount);
      while(!Video.LineCount);
      if(scro>1){
        while(Video.LineCount);
        while(!Video.LineCount);
      }
    }
  }
}

void score(uint b){ // display a number on top right
  char a,c=14;
  for(a=0;a<8;a++)  {  // clear the area
    asciibuf[((a*mapwide)+c)]=0;
    asciibuf[((a*mapwide)+c-1)]=0;
    asciibuf[((a*mapwide)+c)-2]=0;
    asciibuf[((a*mapwide)+c)-3]=0;
  }
  while(b){  // draw the digits
    for(a=0;a<8;a++)  asciibuf[((a*mapwide)+c)]=bitfontdigits[a+((b%10)*8)];
    b=b/10;
    c--;
  }
}

//this works fine but ...
/* 
 void rsft(){  // right shift the screen
 uchar x,y;
 uint z;
 if(songindex){
 for(x=((mapwide-4)*8)-1;x>0;x--){
 for(y=0;y<8;y++){
 if(asciibuf[((x-1)/8)+(y*mapwide)]&_BV((x-1)&7))asciibuf[(x/8)+(y*mapwide)]|=_BV(x&7);
 else asciibuf[(x/8)+(y*mapwide)]&=~_BV(x&7);
 }
 }
 for(x=(mapwide*8)-1;x>0;x--){
 for(y=8;y<maptall;y++){
 if(asciibuf[((x-1)/8)+(y*mapwide)]&_BV((x-1)&7))asciibuf[(x/8)+(y*mapwide)]|=_BV(x&7);
 else asciibuf[(x/8)+(y*mapwide)]&=~_BV(x&7);
 }
 }
 }
 else
 {
 for(x=(mapwide*8)-1;x>0;x--){
 for(y=0;y<maptall;y++){
 if(asciibuf[((x-1)/8)+(y*mapwide)]&_BV((x-1)&7))asciibuf[(x/8)+(y*mapwide)]|=_BV(x&7);
 else asciibuf[(x/8)+(y*mapwide)]&=~_BV(x&7);
 }
 }
 
 }
 }
 */

// this is a little quicker ;-D
void rsft(){  //right shift the screen 
  asm volatile( 
  // can't see our defines from here
  " .equ mapwide, 15\n .equ maptall, 53 \n"
    // working room
  "push r30 \n push r31 \n push r29 \n push r28 \n push r27 \n"
    //check if we skip part of screen for scroll  
  "lds r30,songindex\n lds r31,songindex+1\n or r30,r31\nbreq 3f\n"
    // top 8 lines, skip last 32 bits
  " ldi r29, 8 \n ldi r30,lo8(asciibuf)  \nldi r31,hi8(asciibuf)   \n 2:  ldi r28,mapwide-4\n  ld r27,Z \n ror r27 \n1: \n"
    // shift in/out a bit and replace byte
  "  ld r27,Z \n rol r27 \n st Z+,r27 \n"
    // loops
  "dec r28 \n brne 1b \n adiw r30,4\n dec r29 \n brne 2b \n "
    // rest of screen move full line
  " ldi r29, maptall-8 \n 2:  ldi r28,mapwide\n  ld r27,Z \n ror r27 \n1: \n"
    "  ld r27,Z \n rol r27 \n st Z+,r27 \n"
    "dec r28 \n brne 1b \n dec r29 \n brne 2b \n "
    // go to cleanup exit
  "jmp 4f\n"
    // full screen scroll
  "3: ldi r29, maptall \n ldi r30,lo8(asciibuf)  \nldi r31,hi8(asciibuf)   \n 2:  ldi r28,mapwide\n  ld r27,Z \n ror r27 \n1: \n"
    "  ld r27,Z \n rol r27 \n st Z+,r27 \n"
    "dec r28 \n brne 1b \n dec r29 \n brne 2b \n "
    //clean up and done
  "4:pop r27\npop r28\npop r29\npop r31\npop r30\n"
    "\n\t"::); 
}










