//1. parts
 // MRETV uses a special file Arduino\libraries\MRETV\MRETV.extensions to hold information about extended functions
 // like sound generation. (To know why see the expert section.) To use sound you need to define an Audio type , we will
 //  '#define monoaudio' in this file. (see the 'default_extensions' in MRETV.extensions now.)

 #include <MRETV.h>   // MRETV itself
 #include <textfont.h>   // a font,  default fontheight  is 8
 #include "saw.h"      // some sound samples
 PROGMEM const char * sounds [] = { // optional array of sound samples, must be called 'sounds[]' and in progmem.
   sawCo4,sawDbo4,sawDo4,sawEbo4,sawEo4,sawFo4,sawGbo4,sawGo4,sawAbo4,sawAo4,sawBbo4,sawBo4};
 uchar  Screenbuf [20 * 20]={
   " Use a string here  to set your initial display"};   // some place to put display data, 20 rows of 20 characters

 // 2. begin
 void setup(){  
   Screen.begin(textfont,Screenbuf, 20*fontheight,20,20,20,1);  // start video output, sound is enabled at the same time
   // (font, buffer, ScreenHeight (pix), ScreenWidth (chars), top (pix), left (pix), mode)  top and left are centering, mode=1 for normal text
 }

 //3. update screen
 volatile uint a,depth=0;
 void loop(){
   for(a=4000;a;a--);// slow us down
   Screen_progstr(8,0,"Speed "); // update information as needed
   Screen.dec(56-((int)depth/300));
   Screen_progstr(11,0,"Depth ");
   Screen.hexint(depth++);

 //3. update sound
   if (!(depth&0x07f)) switch(depth/0x80){  // beep now and then
   case 1:
     ssample(sawBo4,50);  // play a sample directly  (sample, duration (1/60sec) )
      break;
   case 17:
     depth=0;
     break;
   default:
    if( (depth/0x80)>5) setaudio((depth/0x80)-6,15); // play a sample from the array  (sample, duration (1/60sec) )
     break;
   }
 }

