/*********************************************************
 * TvText    whmp 2013 7 30 
 *
 * an example for MRETV
 *
 * This sketch will let your Arduino act as an external video card for text
 * only display. Being able to cut and paste to another display is handy
 * for programming.
 *
 * You can also plug the Arduino into your Big screen to leave a text message
 * that are hard to miss. A schedule or menu or leader board on a bigscreen
 * at your charity event. Put your Arduino to work!
 *
 * About Extension defines.
 *
 * Defining these in the MRETV library folder allows for extra optimisation and
 * improved performance. All examples are predefined in Arduino\libraries\MRETV\MRETV.extensions
 *
 * for MasteRasterExtendedTransmissionVision 1
 **********************************************************/


#include <MrETV.h>
#ifndef default_extensions // make sure the extensions are set correctly
#error Please define 'default_extensions' in arduino\libraries\MRETV\MRETV.extensions , See comments at start of sketch
#endif

#include "textfont.h"  // readable font

#ifdef __AVR_ATmega168__
#define asciibufsize 22*40
#else 
#define asciibufsize 25*46
#endif

uchar  asciibuf[asciibufsize];
void setup(){
#ifdef __AVR_ATmega168__
  Screen.begin(textfont,asciibuf, 22*8,40,34,52,1);
#else 
  Screen.begin(textfont,asciibuf, 25*8,46,22,20,1);
#endif
  Video.readS(); //Response from keyboard init should be 0xAA, read it here so it does not print
}

void loop() {
  uchar chin;
#ifdef __AVR_ATmega168__
  Screen_progstr(0,21,"A"); // print at a position to look nice.
  Screen_progstr(2,1, "MasterRasterExtendedTransmissionVision");
  Screen_progstr(4,17, "Example");
#else 
  Screen_progstr(0,23,"A"); // print at a position to look nice.
  Screen_progstr(2,1, "MasterRasterExtendedTransmissionVision");
  Screen_progstr(4,20, "Example");
#endif

  Screen_progstr(6,0, "In a command prompt window type, use your com#");
  Screen_progstr(8,1, "mode com3:2400,n,8,1");
  Screen_progstr(10,1, "Then type ");
  Screen_progstr(11,1, "copy con com3:");
  Screen_progstr(13,1, "Now you can type to the MRETV screen");
  Screen_progstr(14,1, " or 'paste' a text file to there.");
  // while(1); 
  Screen_progstr(16,1, "If you have built the keyboard");
  Screen_progstr(17,1, "port it works here too. ");
  Screen_progstr(18,0,"About 8K adds a full keyboard, video out");
  Screen_progstr(19,1,"Screenprint functions, and a simple ");
  Screen_progstr(20,1,"terminal to your projects while still");
  Screen_progstr(21,1,"maintaining 2400 baud duplex serial.");

  while(1)if((chin=Video.readS()))Screen.render(chin);
  // render is the basic scrolling text terminal service and in not a tiny function.
  // I also hope the Arduino community will port some of their fine work into MRETV
  // this render NEEDS a rewrite
}



