/*********************************************************
 * Ponguino    whmp 2013 7 30
 *
 * an example for MRETV
 *
 * A classic style game - play with paddles or MRETV keyboard.
 * feel free to improve the actual game (and send me a copy!)
 *
 * this code shows how to read and write pixels,
 * read/get a pixel   screenbuf[get(x,y)]&_BV(x&7);  // not 0=set, 0=set
 * set a pixel   screenbuf[get(x,y)]|=_BV(x&7);
 * clear a pixel   screenbuf[get(x,y)]&=~_BV(x&7);
 * eor a pixel   screenbuf[get(x,y)]^=_BV(x&7);
 * clear all      fill(0);
 * set all      fill(255);
 * reverse all      for (t=0;t<mapsize;t++)screenbuf[t]^=255;
 *
 * Note that this example the font is 1 high but the screen pixels are 4 scanlines high
 * This does not change the code from Bounce with 4 high font single scanline pixel !
 *
 * The ADC are all read, some at 1.1v ref some at v ref. 
 * About Extension defines.
 *
 * Defining these in the MRETV library folder allows for extra optimisation and
 * improved performance. All examples are predefined in Arduino\libraries\MRETV\MRETV.extensions
 *
 * for MasteRasterExtendedTransmissionVision 1
 **********************************************************/

//keys qbjrcf <>^v sawz ctrl+sawz nlock
//how fast the game is
#define STARTSKILL 1
#define USEJOY 1

#include <MrETV.h>
#ifndef Ponguino // make sure the extensions are set correctly
#error Please define Ponguino in arduino\libraries\MRETV\MRETV.extensions
#endif
/* **************  the extensions for this sketch
 #define monoaudio    // keep it simple
 #define firmwareps2port   // so its playable without analog hardware
 #define userextension   background()  // used to read analog hardware if available
 #define translatekeys    // simplify keyboard handling
 #define fontheight 1     // a graphics font
 #define fakejoy2         // two player
 ************************* */


#include "bitfont.h" // pixel level graphics, actually has 3 bit fonts and (special) digits 1-9
#include "pongsnd.h" // special sounds
#include "saw.h" // standard sounds
PROGMEM const char *sounds[] = 	{  // only sounds in the array get compiled in.
  silent,Pongo,Pongo1,Pongo2,Pongo3,Pongo4,Pongo5,Pongo6,Pongo7,Gnopo,Gnopo1,Gnopo2,Gnopo3,Gnopo4,Gnopo5,Gnopo6,Gnopo7,sawCo3};

// user interupt extension called screen top -1 and screen bottom +1
volatile uint analog[6]; // paddles + example
uint analogindex;

void background(){ // read adc's and store value, no averaging or summing.
  uchar a;
  if(( Video.LineCount== (Video.ScreenBottom+1U))) { // only one a screen
    union{  // for reading adc
      short val;
      uint8_t val8[2];
    };
    if(ADCSRA&_BV(ADSC)) return;// too early better miss a sample
    val8[0]=ADCL; // read conversion results
    val8[1]=ADCH;

    a=analogindex%8;
    switch(a){
    case 0: // first read after ref change so ignore it.
      break;
    case 1:
      analog[0]=val; // store 0
      ADMUX=ADC_11V|1; // next  1 1v
      break;
    case 2: // first read after ref change so ignore it.
      break;
    case 3: //store 1 next 2 1v
    case 4: //store 2 next 3 1v
    case 5: //store 3 next 4 1v
    case 6: //store 4 next 5 1v
      analog[a-2]=val;
      ADMUX=ADC_11V|(a-1);
      break;
    case 7:
      analog[5]=val; //store 5
      ADMUX=ADC_5V|0; //next 0 5v
    }
    ADCSRA=ADC_START; // start next conversion
    analogindex=(analogindex+1)%8; // increment count
  }
}

//we are not using text so mapwide, maptall, and mapsize let us do some
// basics like clear the screen without importing the BIG screen object

//#define __AVR_ATmega168__   // for testing only
#ifdef __AVR_ATmega168__
#define maptall 50
#else
#define maptall 114
#endif

#define mapwide 16  // actualy 128 (16x8) 
#define mapsize (maptall*mapwide)  

volatile uchar  screenbuf[mapsize]; // the actual MASTER RASTER data
int x,y; // keeping it simple the 'ball' is a pixel

int get(int x, int y){  // get the byte containing a bit for an x,y location on the screen.
  return((x/8)+(y*mapwide));
}
// this does correction
//you might want to just return an error and correct elsewhere with context in your code.
void bounds()   {  // put x and y on screen (and not trashing other mem!)
  if(x<0)  x=0;
  if(x>(mapwide*8)-1)      x=(mapwide*8)-1;
  if(y<0)      y=0;
  if(y>maptall-1)      y=maptall-1;
}

void fill(char d){ // fill the screen with a 1 x 8 pattern
  int t;
  for (t=0;t<mapsize;t++)screenbuf[t]=d;
}

//Some simple big digits for the score
void bitdigit(int dx,int dy, char d){ // put digit d at location x and y, hmm this needs its own kind of bounds check!
  char a;
  for(a=0;a<8;a++){
    screenbuf[(((a+dy)*mapwide)+dx)]=bitfontdigits[a+(d*8)];
  }

}


// skip down to  loop at the bottom unless you really care how the game works
// or doesn't work ...
// Warning crap code ahead

char dirx,diry,chin,bounce,padl=maptall/2,padr=maptall/2,padrtall,padltall,difr,difl,maxv ;
char oldx, oldy,usejoy=1;
uchar scorer,scorel;

void score(){
  uchar b;
  setaudio(17,50);
  bitdigit(1,(scorel/10),scorel%10); // show score
  bitdigit(14,(scorer/10),scorer%10);
  bounds(); // ball onto screen
  screenbuf[get(oldx,oldy)]^=_BV(oldx&7); // artifact
  for(b=0;b<180;b++){  // wait a while
    while(Video.LineCount);
    while(!Video.LineCount);
    chin=Video.read();  //also reads fake joy for pads
    if(chin=='j')usejoy^=1;
    placepads();
    screenbuf[get(x,y)]^=_BV(x&7);
  }
  fill(0);  // in  case of trace!
  bitdigit(1,(scorel/10),scorel%10); // show score
  bitdigit(14,(scorer/10),scorer%10);
  if(!key_nlock)screenbuf[get(oldx,oldy)]^=_BV(oldx&7); // avoid artifact
  placepads();  // show pads
  // serve the ball
  y=maptall/2;
  if(dirx>0){
    diry=(((padr*6)-1)/(maptall-padrtall))-3;  // serve control !
    x=(mapwide*8)-1;
    difr=0;
  }
  else{
    diry=(((padl*6)-1)/(maptall-padltall))-3;
    x=0;
    difl=0;
  }
  dirx*=-1;
  if((diry>1)||(diry<-1)){ // limit side slide serve until skill proven...
    if(!((padltall<15)&&(padrtall<15))){
      if(diry>0)diry=1;
      else diry=-1;
    }
  }
}

void hitpr(){
  char l;
  difr++;
  if(difr==8){
    difr=0;
    if(padrtall>2)
      padrtall-=2;
    if(difl>6)dirx--;
  }
  l=((y-padr)*10)/padrtall;
  switch(l){
  case 0:
  case 10:
    if(!diry)diry=3;
    diry*=-1; // reverse and continue>>>
    setaudio(4,3);
      break;
  case 9:
  case 1:
    if(diry>0) diry++; // increase angle
    else diry--;
    setaudio(3,3);
      break;
  case 4:
  case 6:
    if(diry>0) diry--;  // decrease angle
    else diry++;
    setaudio(2,3);
      break;
  case 5:
    setaudio(5,3);
      diry=0;  // no angle
    break;
  case 8:
  case 7: // no change
  case 2:
  case 3:
    if(!diry)diry++;
    setaudio(1,3);
      break;
  }
}

void hitpl(){
  char l;
  difl++;
  if(difl==8){
    difl=0;
    if(padltall>2)padltall-=2;
    if(difr>6)dirx++;
  }
  l=((y-padl)*10)/padltall;
  switch(l){
  case 0:
  case 10:
    if(!diry)diry=-3;
    diry*=-1; // reverse and continue>>>
    setaudio(4+8,3);
      break;
  case 9:
  case 1:
     if(diry>0) diry++; // increase angle
    else diry--;
    setaudio(3+8,3);
      break;
  case 4:
  case 6:
    if(diry>0) diry--;  // decrease angle
    else diry++;
    setaudio(2+8,3);
      break;
  case 5:
    diry=0;  // no angle
    setaudio(5+8,3);
      break;
  case 8:
  case 7: // no change
  case 2:
  case 3:
    if(!diry)diry--;
    setaudio(1+8,3);
      break;
  }
}

void placepads(){
  char a;
  if(f2jup)if(padl>0)padl--;
  if(f2jdown)if(padl<(maptall-padltall))padl++;
  if(fjup)if(padr>0)padr--;
  if(fjdown)if(padr<(maptall-padrtall))padr++;
  if(usejoy){
#ifdef __AVR_ATmega168__
    padl=((analog[1]/6))-20;
    padr=((analog[2]/6))-20;
#else 
    padl=((analog[1]/3))-20;  // these are more sensitive
    padr=((analog[2]/3))-20;  // further to go
#endif
  }
  for(a=0;a<maptall;a++){
    if(a<padl||a>(padl+padltall))screenbuf[a*mapwide]&=~_BV(0);
    else screenbuf[a*mapwide]|=_BV(0);
    if(a<padr||a>(padr+padrtall))screenbuf[a*mapwide+(mapwide-1)]&=~_BV(7);
    else screenbuf[a*mapwide+(mapwide-1)]|=_BV(7);
  }
}

void checkbounce(){
  placepads();
  if((diry>2)||(diry<-2)){ // limit side slide until skill proven...
    if(!((padltall<15)&&(padrtall<15))){
      if(diry>0)diry=2;
      else diry=-2;
    }
  }
  oldx=x;
  oldy=y;
  x+=dirx;
  y+=diry;
  if(x<=0){
    x=0;
    dirx*=-1;
    if((y<padl)||(y>(padl+padltall))){
      scorer++;
      score();
    }
    else {
      hitpl();
    }
  }
  else  if(x>=(mapwide*8)-1){
    x=(mapwide*8)-1;
    dirx*=-1;
    if((y<padr)||(y>(padr+padrtall))){
      scorel++;
      score();
    }//x=0;
    else{
      hitpr();
    }
  }
  if(y<0){
    y=0;
    diry*=-1;
  }
  else   if(y>(maptall-1)){
    y=(maptall-1);
    diry*=-1;
  }
  bounds();
  if(!key_nlock)   screenbuf[get(oldx,oldy)]^=_BV(oldx&7); //erase old maybe
  screenbuf[get(x,y)]^=_BV(x&7); // place new
  while(Video.LineCount); // not too fast now
}

void setup(){
  // screen pixels are 2 wide 4 high or 2 x 2
  // our screen 58 x 128  or 114 x128
#ifdef __AVR_ATmega168__
  padltall=15;
  padrtall=15;
  Video.begin(bit1font,screenbuf,maptall*fontheight*4,mapwide,17,1,(2<<5)+4);
#else
  padltall=20;
  padrtall=20;
  Video.begin(bit1font,screenbuf,maptall*fontheight*2,mapwide,5,1,(2<<5)+2);
#endif
  Video.read();//Response from keyboard init
}

void loop() {
  padl=0;
  padr=0;
  x=0;
  y=1;
  diry=1;
  dirx=STARTSKILL;
  bounce=1;

  while(1){
    if(bounce)checkbounce(); // move the ball and everything else
    else{  // fast blink
      screenbuf[get(x,y)]^=_BV(x&7); //show where we are against black mor white
      while(Video.LineCount);
      screenbuf[get(x,y)]^=_BV(x&7);
      while(Video.LineCount);
    }
    if ((chin=Video.read()))  // handle user input and update fakejoy
    {
      if(chin=='q')   asm volatile("JMP 0x0000\n\t"::); // reset
      if(chin=='b'){  // stop and start the ball
        screenbuf[get(x,y)]^=_BV(x&7); // try to avoid artifact
        bounce^=1;
      }
      if(chin=='j'){usejoy^=1;padl=maptall/2,padr=maptall/2;}
      if(chin=='r'){  // kill the balls velocity
        dirx=0;
        diry=0;
      }
      if(chin=='c') fill(0);  // clear screen
      if(chin=='f') fill(255);  // fill screen
      if(key_ctr){  // manual velocity set
        if(chin=='d')dirx++;
        if(chin=='a')dirx--;
        if(chin=='w')diry++;
        if(chin=='s')diry--;
      }
    }
  }
}











