
/*********************************************************
 * TestPattern    whmp 2013 7 30
 * 
 * an example for MRETV 
 * 
 * About 1.5 k, basic overhead of MasterRasterTransmissionVision, 
 * no extensions about 18 bytes, plus 14 bytes of stack for 
 * interrupt= 32 bytes. plus the character array (1 to 1400?2800? bytes)
 * 
 * Two calls are required to generate video.
 * 
 * void Video.setup();
 * void begin( const prog_char* CharBase, // The character shapes
 * volatile uchar * textbuf,  // the character array
 * uchar lines,               // height of screen in pixels    
 * uchar cols,                // width of the screen in pixels / 8
 * uchar top,                 // screen centering 
 * uchar left,                // screen centering  
 * uchar mode);               // pixel size bits 0-4 height, bits 5-7 width
 * 
 * About Extension defines.
 * 
 * Defining these in the MRETV library folder allows for extra optimisation and 
 * improved performance. All examples are predefined in Arduino\libraries\MRETV\MRETV.extensions 
 * 
 * for MasteRasterExtendedTransmissionVision 1
 **********************************************************/

#include <MrETV.h>

#ifndef TestPattern // make sure the extensions are set correctly
#error Please define TestPattern in arduino\libraries\MRETV\MRETV.extensions 
#endif
/***************   extensions for sketch used in arduino\libraries\MRETV\MRETV.extensions
 * #define fontheight 16  //overrides the default 8
 **************************/

// an array of characters. Not really ascii, but an index into the characterset
volatile uchar asciibuf[672];
// 8 x 16 characters ,a font/characterset is usually 8x8, and usually in a font.h 
const prog_char testpatternfont [16]  PROGMEM =  // how to properly stop the warning?
{ 
  1,2,4,8,16,32,64,128,
  128,64,32,16,8,4,2,1,
};

void setup(){ 
  Video.begin(testpatternfont,asciibuf, 224,48,9,20,1); // start the video
}

void loop() {  // once started Video runs by itself in the background
}




